// Code generated by "enumer -type=SyncStrategy -json -text -yaml -sql"; DO NOT EDIT.

//
package syncStrategyTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _SyncStrategyName = "UnknownCombineExportResetToDBResetToRemoteStatus"

var _SyncStrategyIndex = [...]uint8{0, 7, 14, 20, 29, 42, 48}

func (i SyncStrategy) String() string {
	if i < 0 || i >= SyncStrategy(len(_SyncStrategyIndex)-1) {
		return fmt.Sprintf("SyncStrategy(%d)", i)
	}
	return _SyncStrategyName[_SyncStrategyIndex[i]:_SyncStrategyIndex[i+1]]
}

var _SyncStrategyValues = []SyncStrategy{0, 1, 2, 3, 4, 5}

var _SyncStrategyNameToValueMap = map[string]SyncStrategy{
	_SyncStrategyName[0:7]:   0,
	_SyncStrategyName[7:14]:  1,
	_SyncStrategyName[14:20]: 2,
	_SyncStrategyName[20:29]: 3,
	_SyncStrategyName[29:42]: 4,
	_SyncStrategyName[42:48]: 5,
}

// SyncStrategyString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func SyncStrategyString(s string) (SyncStrategy, error) {
	if val, ok := _SyncStrategyNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to SyncStrategy values", s)
}

// SyncStrategyValues returns all values of the enum
func SyncStrategyValues() []SyncStrategy {
	return _SyncStrategyValues
}

// IsASyncStrategy returns "true" if the value is listed in the enum definition. "false" otherwise
func (i SyncStrategy) IsASyncStrategy() bool {
	for _, v := range _SyncStrategyValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for SyncStrategy
func (i SyncStrategy) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for SyncStrategy
func (i *SyncStrategy) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("SyncStrategy should be a string, got %s", data)
	}

	var err error
	*i, err = SyncStrategyString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for SyncStrategy
func (i SyncStrategy) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for SyncStrategy
func (i *SyncStrategy) UnmarshalText(text []byte) error {
	var err error
	*i, err = SyncStrategyString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for SyncStrategy
func (i SyncStrategy) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for SyncStrategy
func (i *SyncStrategy) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = SyncStrategyString(s)
	return err
}

func (i SyncStrategy) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *SyncStrategy) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := SyncStrategyString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
